
CoCoA-5 - Feature #927

Add "exit" in addition to "ciao"

21 Sep 2016 17:52 - Anna Maria Bigatti

Status: Closed Start date: 21 Sep 2016

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: CoCoA-5 function: new Estimated time: 1.56 hour

Target version: CoCoA-5.2.0 spring 2017 Spent time: 1.55 hour

Description

Related issues:

Related to CoCoA-5 - Bug #928: ciao, exit, quit can be used not only at top l... New 21 Sep 2016

History

#1 - 21 Sep 2016 17:52 - Anna Maria Bigatti

- Target version set to CoCoA-5.2.0 spring 2017

#2 - 21 Sep 2016 21:32 - John Abbott

- Category set to CoCoA-5 function: new

I think it should not be too hard to add an "exit" command, but this means introducing a new keyword which could, in principle, break existing code (if

someone has used "exit" as a variable/fn name).

#3 - 21 Sep 2016 22:00 - John Abbott

- Status changed from New to Resolved

- Assignee set to John Abbott

- % Done changed from 0 to 80

What I did to add command "exit".

cd src/CoCoA-5

fgrep Ciao Lexer.C

--> Keyword("Ciao", TT_CIAO)

In Lexer.H  add TT_EXIT  to enum TokenType

In Lexer.C add  Keyword("Exit", TT_EXIT) to keywordTable

In Parser.C 3 changes:

(1) add case TT_EXIT to UnexpectedTokenException::humanReadable(...)

(2) add case TT_EXIT to mayStartOrFollowAStatement(...)

(3) add case TT_EXIT to Parser::parseFunBodyStatement()

In AST.C  2 changes:

(1)  add appropriate dumpAsString(...) mem fn

[in this case just modify an existing one]

(2)  add appropriate DumpAsTreeVisitor::visit(...) fn

[in this case just modify an existing one]

In C5.C  add "Exit" to keywordRE (in CocoaHighlighter ctor around line 460)

Running "make" produced a CoCoAInterpreter but "exit" did not work properly.

After doing "make clean; make" it worked fine.

PS I also added "exit" to the CoCoAManual!
#4 - 21 Sep 2016 22:04 - John Abbott

- Related to Bug #928: ciao, exit, quit can be used not only at top level added

#5 - 10 Oct 2016 13:51 - John Abbott

I have added the keywords exit and quit to the file cocoa5.el.

#6 - 13 Oct 2016 17:45 - John Abbott

- Status changed from Resolved to Feedback

- % Done changed from 80 to 90

I have also change the "goodbye pop-up window" in the GUI so that it says "Ciao" instead of "Bye".

#7 - 01 Mar 2017 14:15 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 1.56 h
